import{S as zn,i as Gn,s as Bn,e as a,k as d,w as _,t as r,M as Jn,c as n,d as t,m as c,a as s,x as v,h as l,b as f,G as o,g as m,y as b,q as k,o as w,B as y,v as Kn,L as Rn}from"../../chunks/vendor-hf-doc-builder.js";import{T as Wn}from"../../chunks/Tip-hf-doc-builder.js";import{D as T}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Vn}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ge}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Sn}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Qn(O){let p,D,g,u,x;return u=new Vn({props:{code:`import torch.nn as nn
from accelerate import init_empty_weights

# Initialize a model with 100 billions parameters in no time and without using any RAM.
with init_empty_weights():
    tst = nn.Sequential(*[nn.Linear(10000, 10000) for _ in range(1000)])`,highlighted:`<span class="hljs-keyword">import</span> torch.nn <span class="hljs-keyword">as</span> nn
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> init_empty_weights

<span class="hljs-comment"># Initialize a model with 100 billions parameters in no time and without using any RAM.</span>
<span class="hljs-keyword">with</span> init_empty_weights():
    tst = nn.Sequential(*[nn.Linear(<span class="hljs-number">10000</span>, <span class="hljs-number">10000</span>) <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">1000</span>)])`}}),{c(){p=a("p"),D=r("Example:"),g=d(),_(u.$$.fragment)},l(i){p=n(i,"P",{});var $=s(p);D=l($,"Example:"),$.forEach(t),g=c(i),v(u.$$.fragment,i)},m(i,$){m(i,p,$),o(p,D),m(i,g,$),b(u,i,$),x=!0},p:Rn,i(i){x||(k(u.$$.fragment,i),x=!0)},o(i){w(u.$$.fragment,i),x=!1},d(i){i&&t(p),i&&t(g),y(u,i)}}}function Xn(O){let p,D,g,u,x,i,$,N;return{c(){p=a("p"),D=r(`Any model created under this context manager has no weights. As such you can\u2019t do something like
`),g=a("code"),u=r("model.to(some_device)"),x=r(" with it. To load weights inside your empty model, see "),i=a("a"),$=r("load_checkpoint_and_dispatch()"),N=r("."),this.h()},l(P){p=n(P,"P",{});var E=s(p);D=l(E,`Any model created under this context manager has no weights. As such you can\u2019t do something like
`),g=n(E,"CODE",{});var L=s(g);u=l(L,"model.to(some_device)"),L.forEach(t),x=l(E," with it. To load weights inside your empty model, see "),i=n(E,"A",{href:!0});var H=s(i);$=l(H,"load_checkpoint_and_dispatch()"),H.forEach(t),N=l(E,"."),E.forEach(t),this.h()},h(){f(i,"href","/docs/accelerate/v0.19.0/en/package_reference/big_modeling#accelerate.load_checkpoint_and_dispatch")},m(P,E){m(P,p,E),o(p,D),o(p,g),o(g,u),o(p,x),o(p,i),o(i,$),o(p,N)},d(P){P&&t(p)}}}function Yn(O){let p,D,g,u,x;return u=new Vn({props:{code:`from accelerate import init_empty_weights, load_checkpoint_and_dispatch
from huggingface_hub import hf_hub_download
from transformers import AutoConfig, AutoModelForCausalLM

# Download the Weights
checkpoint = "EleutherAI/gpt-j-6B"
weights_location = hf_hub_download(checkpoint, "pytorch_model.bin")

# Create a model and initialize it with empty weights
config = AutoConfig.from_pretrained(checkpoint)
with init_empty_weights():
    model = AutoModelForCausalLM.from_config(config)

# Load the checkpoint and dispatch it to the right devices
model = load_checkpoint_and_dispatch(
    model, weights_location, device_map="auto", no_split_module_classes=["GPTJBlock"]
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> init_empty_weights, load_checkpoint_and_dispatch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> hf_hub_download
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoConfig, AutoModelForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download the Weights</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>checkpoint = <span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>weights_location = hf_hub_download(checkpoint, <span class="hljs-string">&quot;pytorch_model.bin&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Create a model and initialize it with empty weights</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>config = AutoConfig.from_pretrained(checkpoint)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> init_empty_weights():
<span class="hljs-meta">... </span>    model = AutoModelForCausalLM.from_config(config)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load the checkpoint and dispatch it to the right devices</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = load_checkpoint_and_dispatch(
<span class="hljs-meta">... </span>    model, weights_location, device_map=<span class="hljs-string">&quot;auto&quot;</span>, no_split_module_classes=[<span class="hljs-string">&quot;GPTJBlock&quot;</span>]
<span class="hljs-meta">... </span>)`}}),{c(){p=a("p"),D=r("Example:"),g=d(),_(u.$$.fragment)},l(i){p=n(i,"P",{});var $=s(p);D=l($,"Example:"),$.forEach(t),g=c(i),v(u.$$.fragment,i)},m(i,$){m(i,p,$),o(p,D),m(i,g,$),b(u,i,$),x=!0},p:Rn,i(i){x||(k(u.$$.fragment,i),x=!0)},o(i){w(u.$$.fragment,i),x=!1},d(i){i&&t(p),i&&t(g),y(u,i)}}}function Zn(O){let p,D,g,u,x,i,$,N;return{c(){p=a("p"),D=r(`If the module already contains a hook, this will replace it with the new hook passed by default. To chain two hooks
together, pass `),g=a("code"),u=r("append=True"),x=r(", so it chains the current and new hook into an instance of the "),i=a("code"),$=r("SequentialHook"),N=r(" class.")},l(P){p=n(P,"P",{});var E=s(p);D=l(E,`If the module already contains a hook, this will replace it with the new hook passed by default. To chain two hooks
together, pass `),g=n(E,"CODE",{});var L=s(g);u=l(L,"append=True"),L.forEach(t),x=l(E,", so it chains the current and new hook into an instance of the "),i=n(E,"CODE",{});var H=s(i);$=l(H,"SequentialHook"),H.forEach(t),N=l(E," class."),E.forEach(t)},m(P,E){m(P,p,E),o(p,D),o(p,g),o(g,u),o(p,x),o(p,i),o(i,$),o(p,N)},d(P){P&&t(p)}}}function es(O){let p,D,g,u,x,i,$,N,P,E,L,H,Be,ue,$t,Je,xt,No,C,ge,Et,Ke,At,Dt,oe,Tt,te,Co,W,_e,Mt,Qe,Pt,Uo,S,ve,Lt,Xe,Ht,Fo,R,be,jt,Ye,Nt,Io,U,ke,Ct,Ze,Ut,Ft,ae,qo,V,ne,eo,we,It,oo,qt,Oo,z,se,to,ye,Ot,ao,Wt,Wo,A,$e,St,no,Rt,Vt,so,zt,Gt,ro,j,lo,Bt,Jt,co,Kt,Qt,io,Xt,Yt,ho,Zt,ea,mo,oa,ta,aa,re,xe,na,po,sa,ra,le,Ee,la,fo,da,ca,de,Ae,ia,uo,ha,ma,ce,De,pa,go,fa,So,G,Te,ua,Me,ga,_o,_a,va,Ro,B,Pe,ba,vo,ka,Vo,J,ie,bo,Le,wa,ko,ya,zo,F,He,$a,I,xa,wo,Ea,Aa,yo,Da,Ta,$o,Ma,Pa,La,he,Go,K,je,Ha,Ne,ja,xo,Na,Ca,Bo,Q,Ce,Ua,Ue,Fa,Eo,Ia,qa,Jo,X,Fe,Oa,Ie,Wa,Ao,Sa,Ra,Ko,Y,me,Do,qe,Va,To,za,Qo,Z,Oe,Ga,We,Ba,Mo,Ja,Ka,Xo,ee,Se,Qa,Po,Xa,Yo;return i=new Ge({}),ue=new Ge({}),ge=new T({props:{name:"accelerate.init_empty_weights",anchor:"accelerate.init_empty_weights",parameters:[{name:"include_buffers",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.init_empty_weights.include_buffers",description:`<strong>include_buffers</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to also put all buffers on the meta device while initializing.`,name:"include_buffers"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/big_modeling.py#L44"}}),oe=new Sn({props:{anchor:"accelerate.init_empty_weights.example",$$slots:{default:[Qn]},$$scope:{ctx:O}}}),te=new Wn({props:{warning:!0,$$slots:{default:[Xn]},$$scope:{ctx:O}}}),_e=new T({props:{name:"accelerate.cpu_offload",anchor:"accelerate.cpu_offload",parameters:[{name:"model",val:": Module"},{name:"execution_device",val:": typing.Optional[torch.device] = None"},{name:"offload_buffers",val:": bool = False"},{name:"state_dict",val:": typing.Union[typing.Dict[str, torch.Tensor], NoneType] = None"},{name:"preload_module_classes",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"accelerate.cpu_offload.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
The model to offload.`,name:"model"},{anchor:"accelerate.cpu_offload.execution_device",description:`<strong>execution_device</strong> (<code>torch.device</code>, <em>optional</em>) &#x2014;
The device on which the forward pass of the model will be executed (should be a GPU). Will default to the
model first parameter device.`,name:"execution_device"},{anchor:"accelerate.cpu_offload.offload_buffers",description:`<strong>offload_buffers</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to offload the buffers with the model parameters.`,name:"offload_buffers"},{anchor:"accelerate.cpu_offload.state_dict",description:`<strong>state_dict</strong> (<code>Dict[str, torch.Tensor]</code>, <em>optional</em>) &#x2014;
The state dict of the model that will be kept on CPU.`,name:"state_dict"},{anchor:"accelerate.cpu_offload.preload_module_classes",description:`<strong>preload_module_classes</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
A list of classes whose instances should load all their weights (even in the submodules) at the beginning
of the forward. This should only be used for classes that have submodules which are registered but not
called directly during the forward, for instance if a <code>dense</code> linear layer is registered, but at forward,
<code>dense.weight</code> and <code>dense.bias</code> are used in some operations instead of calling <code>dense</code> directly.`,name:"preload_module_classes"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/big_modeling.py#L146"}}),ve=new T({props:{name:"accelerate.disk_offload",anchor:"accelerate.disk_offload",parameters:[{name:"model",val:": Module"},{name:"offload_dir",val:": typing.Union[str, os.PathLike]"},{name:"execution_device",val:": typing.Optional[torch.device] = None"},{name:"offload_buffers",val:": bool = False"},{name:"preload_module_classes",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"accelerate.disk_offload.model",description:"<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014; The model to offload.",name:"model"},{anchor:"accelerate.disk_offload.offload_dir",description:`<strong>offload_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The folder in which to offload the model weights (or where the model weights are already offloaded).`,name:"offload_dir"},{anchor:"accelerate.disk_offload.execution_device",description:`<strong>execution_device</strong> (<code>torch.device</code>, <em>optional</em>) &#x2014;
The device on which the forward pass of the model will be executed (should be a GPU). Will default to the
model&#x2019;s first parameter device.`,name:"execution_device"},{anchor:"accelerate.disk_offload.offload_buffers",description:`<strong>offload_buffers</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to offload the buffers with the model parameters.`,name:"offload_buffers"},{anchor:"accelerate.disk_offload.preload_module_classes",description:`<strong>preload_module_classes</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
A list of classes whose instances should load all their weights (even in the submodules) at the beginning
of the forward. This should only be used for classes that have submodules which are registered but not
called directly during the forward, for instance if a <code>dense</code> linear layer is registered, but at forward,
<code>dense.weight</code> and <code>dense.bias</code> are used in some operations instead of calling <code>dense</code> directly.`,name:"preload_module_classes"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/big_modeling.py#L238"}}),be=new T({props:{name:"accelerate.dispatch_model",anchor:"accelerate.dispatch_model",parameters:[{name:"model",val:": Module"},{name:"device_map",val:": typing.Dict[str, typing.Union[str, int, torch.device]]"},{name:"main_device",val:": typing.Optional[torch.device] = None"},{name:"state_dict",val:": typing.Union[typing.Dict[str, torch.Tensor], NoneType] = None"},{name:"offload_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"offload_index",val:": typing.Union[typing.Dict[str, str], NoneType] = None"},{name:"offload_buffers",val:": bool = False"},{name:"preload_module_classes",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"accelerate.dispatch_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
The model to dispatch.`,name:"model"},{anchor:"accelerate.dispatch_model.device_map",description:`<strong>device_map</strong> (<code>Dict[str, Union[str, int, torch.device]]</code>) &#x2014;
A dictionary mapping module names in the models <code>state_dict</code> to the device they should go to. Note that
<code>&quot;disk&quot;</code> is accepted even if it&#x2019;s not a proper value for <code>torch.device</code>.`,name:"device_map"},{anchor:"accelerate.dispatch_model.main_device",description:`<strong>main_device</strong> (<code>str</code>, <code>int</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The main execution device. Will default to the first device in the <code>device_map</code> different from <code>&quot;cpu&quot;</code> or
<code>&quot;disk&quot;</code>.`,name:"main_device"},{anchor:"accelerate.dispatch_model.state_dict",description:`<strong>state_dict</strong> (<code>Dict[str, torch.Tensor]</code>, <em>optional</em>) &#x2014;
The state dict of the part of the model that will be kept on CPU.`,name:"state_dict"},{anchor:"accelerate.dispatch_model.offload_dir",description:`<strong>offload_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The folder in which to offload the model weights (or where the model weights are already offloaded).`,name:"offload_dir"},{anchor:"accelerate.dispatch_model.offload_index",description:`<strong>offload_index</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
A dictionary from weight name to their information (<code>dtype</code>/ <code>shape</code> or safetensors filename). Will default
to the index saved in <code>save_folder</code>.`,name:"offload_index"},{anchor:"accelerate.dispatch_model.offload_buffers",description:`<strong>offload_buffers</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to offload the buffers with the model parameters.`,name:"offload_buffers"},{anchor:"accelerate.dispatch_model.preload_module_classes",description:`<strong>preload_module_classes</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
A list of classes whose instances should load all their weights (even in the submodules) at the beginning
of the forward. This should only be used for classes that have submodules which are registered but not
called directly during the forward, for instance if a <code>dense</code> linear layer is registered, but at forward,
<code>dense.weight</code> and <code>dense.bias</code> are used in some operations instead of calling <code>dense</code> directly.`,name:"preload_module_classes"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/big_modeling.py#L286"}}),ke=new T({props:{name:"accelerate.load_checkpoint_and_dispatch",anchor:"accelerate.load_checkpoint_and_dispatch",parameters:[{name:"model",val:": Module"},{name:"checkpoint",val:": typing.Union[str, os.PathLike]"},{name:"device_map",val:": typing.Union[str, typing.Dict[str, typing.Union[str, int, torch.device]], NoneType] = None"},{name:"max_memory",val:": typing.Union[typing.Dict[typing.Union[int, str], typing.Union[int, str]], NoneType] = None"},{name:"no_split_module_classes",val:": typing.Optional[typing.List[str]] = None"},{name:"offload_folder",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"offload_buffers",val:": bool = False"},{name:"dtype",val:": typing.Union[str, torch.dtype, NoneType] = None"},{name:"offload_state_dict",val:": typing.Optional[bool] = None"},{name:"preload_module_classes",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"accelerate.load_checkpoint_and_dispatch.model",description:"<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014; The model in which we want to load a checkpoint.",name:"model"},{anchor:"accelerate.load_checkpoint_and_dispatch.checkpoint",description:`<strong>checkpoint</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The folder checkpoint to load. It can be:</p>
<ul>
<li>a path to a file containing a whole model state dict</li>
<li>a path to a <code>.json</code> file containing the index to a sharded checkpoint</li>
<li>a path to a folder containing a unique <code>.index.json</code> file and the shards of a checkpoint.</li>
</ul>`,name:"checkpoint"},{anchor:"accelerate.load_checkpoint_and_dispatch.device_map",description:`<strong>device_map</strong> (<code>Dict[str, Union[int, str, torch.device]]</code>, <em>optional</em>) &#x2014;
A map that specifies where each submodule should go. It doesn&#x2019;t need to be refined to each parameter/buffer
name, once a given module name is inside, every submodule of it will be sent to the same device.</p>
<p>To have Accelerate compute the most optimized <code>device_map</code> automatically, set <code>device_map=&quot;auto&quot;</code>. For more
information about each option see <a href="big_modeling#designing-a-device-map">here</a>.`,name:"device_map"},{anchor:"accelerate.load_checkpoint_and_dispatch.max_memory",description:`<strong>max_memory</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
A dictionary device identifier to maximum memory. Will default to the maximum memory available for each GPU
and the available CPU RAM if unset.`,name:"max_memory"},{anchor:"accelerate.load_checkpoint_and_dispatch.no_split_module_classes",description:`<strong>no_split_module_classes</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
A list of layer class names that should never be split across device (for instance any layer that has a
residual connection).`,name:"no_split_module_classes"},{anchor:"accelerate.load_checkpoint_and_dispatch.offload_folder",description:`<strong>offload_folder</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
If the <code>device_map</code> contains any value <code>&quot;disk&quot;</code>, the folder where we will offload weights.`,name:"offload_folder"},{anchor:"accelerate.load_checkpoint_and_dispatch.offload_buffers",description:`<strong>offload_buffers</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
In the layers that are offloaded on the CPU or the hard drive, whether or not to offload the buffers as
well as the parameters.`,name:"offload_buffers"},{anchor:"accelerate.load_checkpoint_and_dispatch.dtype",description:`<strong>dtype</strong> (<code>str</code> or <code>torch.dtype</code>, <em>optional</em>) &#x2014;
If provided, the weights will be converted to that type when loaded.`,name:"dtype"},{anchor:"accelerate.load_checkpoint_and_dispatch.offload_state_dict",description:`<strong>offload_state_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If <code>True</code>, will temporarily offload the CPU state dict on the hard drive to avoid getting out of CPU RAM if
the weight of the CPU state dict + the biggest shard does not fit. Will default to <code>True</code> if the device map
picked contains <code>&quot;disk&quot;</code> values.`,name:"offload_state_dict"},{anchor:"accelerate.load_checkpoint_and_dispatch.preload_module_classes",description:`<strong>preload_module_classes</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
A list of classes whose instances should load all their weights (even in the submodules) at the beginning
of the forward. This should only be used for classes that have submodules which are registered but not
called directly during the forward, for instance if a <code>dense</code> linear layer is registered, but at forward,
<code>dense.weight</code> and <code>dense.bias</code> are used in some operations instead of calling <code>dense</code> directly.`,name:"preload_module_classes"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/big_modeling.py#L384"}}),ae=new Sn({props:{anchor:"accelerate.load_checkpoint_and_dispatch.example",$$slots:{default:[Yn]},$$scope:{ctx:O}}}),we=new Ge({}),ye=new Ge({}),$e=new T({props:{name:"class accelerate.hooks.ModelHook",anchor:"accelerate.hooks.ModelHook",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L31"}}),xe=new T({props:{name:"detach_hook",anchor:"accelerate.hooks.ModelHook.detach_hook",parameters:[{name:"module",val:""}],parametersDescription:[{anchor:"accelerate.hooks.ModelHook.detach_hook.module",description:"<strong>module</strong> (<code>torch.nn.Module</code>) &#x2014; The module detached from this hook.",name:"module"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L79"}}),Ee=new T({props:{name:"init_hook",anchor:"accelerate.hooks.ModelHook.init_hook",parameters:[{name:"module",val:""}],parametersDescription:[{anchor:"accelerate.hooks.ModelHook.init_hook.module",description:"<strong>module</strong> (<code>torch.nn.Module</code>) &#x2014; The module attached to this hook.",name:"module"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L43"}}),Ae=new T({props:{name:"post_forward",anchor:"accelerate.hooks.ModelHook.post_forward",parameters:[{name:"module",val:""},{name:"output",val:""}],parametersDescription:[{anchor:"accelerate.hooks.ModelHook.post_forward.module",description:"<strong>module</strong> (<code>torch.nn.Module</code>) &#x2014; The module whose forward pass been executed just before this event.",name:"module"},{anchor:"accelerate.hooks.ModelHook.post_forward.output",description:"<strong>output</strong> (<code>Any</code>) &#x2014; The output of the module.",name:"output"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L66",returnDescription:`
<p>The processed <code>output</code>.</p>
`,returnType:`
<p><code>Any</code></p>
`}}),De=new T({props:{name:"pre_forward",anchor:"accelerate.hooks.ModelHook.pre_forward",parameters:[{name:"module",val:""},{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"accelerate.hooks.ModelHook.pre_forward.module",description:"<strong>module</strong> (<code>torch.nn.Module</code>) &#x2014; The module whose forward pass will be executed just after this event.",name:"module"},{anchor:"accelerate.hooks.ModelHook.pre_forward.args",description:"<strong>args</strong> (<code>Tuple[Any]</code>) &#x2014; The positional arguments passed to the module.",name:"args"},{anchor:"accelerate.hooks.ModelHook.pre_forward.kwargs",description:"<strong>kwargs</strong> (<code>Dict[Str, Any]</code>) &#x2014; The keyword arguments passed to the module.",name:"kwargs"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L52",returnDescription:`
<p>A tuple with the treated <code>args</code> and <code>kwargs</code>.</p>
`,returnType:`
<p><code>Tuple[Tuple[Any], Dict[Str, Any]]</code></p>
`}}),Te=new T({props:{name:"class accelerate.hooks.AlignDevicesHook",anchor:"accelerate.hooks.AlignDevicesHook",parameters:[{name:"execution_device",val:": typing.Union[int, str, torch.device, NoneType] = None"},{name:"offload",val:": bool = False"},{name:"io_same_device",val:": bool = False"},{name:"weights_map",val:": typing.Optional[typing.Mapping] = None"},{name:"offload_buffers",val:": bool = False"},{name:"place_submodules",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.hooks.AlignDevicesHook.execution_device",description:`<strong>execution_device</strong> (<code>torch.device</code>, <em>optional</em>) &#x2014;
The device on which inputs and model weights should be placed before the forward pass.`,name:"execution_device"},{anchor:"accelerate.hooks.AlignDevicesHook.offload",description:`<strong>offload</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the weights should be offloaded after the forward pass.`,name:"offload"},{anchor:"accelerate.hooks.AlignDevicesHook.io_same_device",description:`<strong>io_same_device</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the output should be placed on the same device as the input was.`,name:"io_same_device"},{anchor:"accelerate.hooks.AlignDevicesHook.weights_map",description:`<strong>weights_map</strong> (<code>Mapping[str, torch.Tensor]</code>, <em>optional</em>) &#x2014;
When the model weights are offloaded, a (potentially lazy) map from param names to the tensor values.`,name:"weights_map"},{anchor:"accelerate.hooks.AlignDevicesHook.offload_buffers",description:`<strong>offload_buffers</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to include the associated module&#x2019;s buffers when offloading.`,name:"offload_buffers"},{anchor:"accelerate.hooks.AlignDevicesHook.place_submodules",description:`<strong>place_submodules</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to place the submodules on <code>execution_device</code> during the <code>init_hook</code> event.`,name:"place_submodules"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L200"}}),Pe=new T({props:{name:"class accelerate.hooks.SequentialHook",anchor:"accelerate.hooks.SequentialHook",parameters:[{name:"*hooks",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L89"}}),Le=new Ge({}),He=new T({props:{name:"accelerate.hooks.add_hook_to_module",anchor:"accelerate.hooks.add_hook_to_module",parameters:[{name:"module",val:": Module"},{name:"hook",val:": ModelHook"},{name:"append",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.hooks.add_hook_to_module.module",description:`<strong>module</strong> (<code>torch.nn.Module</code>) &#x2014;
The module to attach a hook to.`,name:"module"},{anchor:"accelerate.hooks.add_hook_to_module.hook",description:`<strong>hook</strong> (<code>ModelHook</code>) &#x2014;
The hook to attach.`,name:"hook"},{anchor:"accelerate.hooks.add_hook_to_module.append",description:`<strong>append</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the hook should be chained with an existing one (if module already contains a hook) or not.`,name:"append"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L118",returnDescription:`
<p>The same module, with the hook attached (the module is modified in place, so the result can
be discarded).</p>
`,returnType:`
<p><code>torch.nn.Module</code></p>
`}}),he=new Wn({props:{warning:!0,$$slots:{default:[Zn]},$$scope:{ctx:O}}}),je=new T({props:{name:"accelerate.hooks.attach_execution_device_hook",anchor:"accelerate.hooks.attach_execution_device_hook",parameters:[{name:"module",val:": Module"},{name:"execution_device",val:": typing.Union[int, str, torch.device]"},{name:"preload_module_classes",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"accelerate.hooks.attach_execution_device_hook.module",description:`<strong>module</strong> (<code>torch.nn.Module</code>) &#x2014;
The module where we want to attach the hooks.`,name:"module"},{anchor:"accelerate.hooks.attach_execution_device_hook.execution_device",description:`<strong>execution_device</strong> (<code>int</code>, <code>str</code> or <code>torch.device</code>) &#x2014;
The device on which inputs and model weights should be placed before the forward pass.`,name:"execution_device"},{anchor:"accelerate.hooks.attach_execution_device_hook.preload_module_classes",description:`<strong>preload_module_classes</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
A list of classes whose instances should load all their weights (even in the submodules) at the beginning
of the forward. This should only be used for classes that have submodules which are registered but not
called directly during the forward, for instance if a <code>dense</code> linear layer is registered, but at forward,
<code>dense.weight</code> and <code>dense.bias</code> are used in some operations instead of calling <code>dense</code> directly.`,name:"preload_module_classes"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L303"}}),Ce=new T({props:{name:"accelerate.hooks.attach_align_device_hook",anchor:"accelerate.hooks.attach_align_device_hook",parameters:[{name:"module",val:": Module"},{name:"execution_device",val:": typing.Optional[torch.device] = None"},{name:"offload",val:": bool = False"},{name:"weights_map",val:": typing.Optional[typing.Mapping] = None"},{name:"offload_buffers",val:": bool = False"},{name:"module_name",val:": str = ''"},{name:"preload_module_classes",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"accelerate.hooks.attach_align_device_hook.module",description:`<strong>module</strong> (<code>torch.nn.Module</code>) &#x2014;
The module where we want to attach the hooks.`,name:"module"},{anchor:"accelerate.hooks.attach_align_device_hook.execution_device",description:`<strong>execution_device</strong> (<code>torch.device</code>, <em>optional</em>) &#x2014;
The device on which inputs and model weights should be placed before the forward pass.`,name:"execution_device"},{anchor:"accelerate.hooks.attach_align_device_hook.offload",description:`<strong>offload</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the weights should be offloaded after the forward pass.`,name:"offload"},{anchor:"accelerate.hooks.attach_align_device_hook.weights_map",description:`<strong>weights_map</strong> (<code>Mapping[str, torch.Tensor]</code>, <em>optional</em>) &#x2014;
When the model weights are offloaded, a (potentially lazy) map from param names to the tensor values.`,name:"weights_map"},{anchor:"accelerate.hooks.attach_align_device_hook.offload_buffers",description:`<strong>offload_buffers</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to include the associated module&#x2019;s buffers when offloading.`,name:"offload_buffers"},{anchor:"accelerate.hooks.attach_align_device_hook.module_name",description:`<strong>module_name</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
The name of the module.`,name:"module_name"},{anchor:"accelerate.hooks.attach_align_device_hook.preload_module_classes",description:`<strong>preload_module_classes</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
A list of classes whose instances should load all their weights (even in the submodules) at the beginning
of the forward. This should only be used for classes that have submodules which are registered but not
called directly during the forward, for instance if a <code>dense</code> linear layer is registered, but at forward,
<code>dense.weight</code> and <code>dense.bias</code> are used in some operations instead of calling <code>dense</code> directly.`,name:"preload_module_classes"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L334"}}),Fe=new T({props:{name:"accelerate.hooks.attach_align_device_hook_on_blocks",anchor:"accelerate.hooks.attach_align_device_hook_on_blocks",parameters:[{name:"module",val:": Module"},{name:"execution_device",val:": typing.Union[torch.device, typing.Dict[str, torch.device], NoneType] = None"},{name:"offload",val:": typing.Union[bool, typing.Dict[str, bool]] = False"},{name:"weights_map",val:": typing.Mapping = None"},{name:"offload_buffers",val:": bool = False"},{name:"module_name",val:": str = ''"},{name:"preload_module_classes",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"accelerate.hooks.attach_align_device_hook_on_blocks.module",description:`<strong>module</strong> (<code>torch.nn.Module</code>) &#x2014;
The module where we want to attach the hooks.`,name:"module"},{anchor:"accelerate.hooks.attach_align_device_hook_on_blocks.execution_device",description:`<strong>execution_device</strong> (<code>torch.device</code> or <code>Dict[str, torch.device]</code>, <em>optional</em>) &#x2014;
The device on which inputs and model weights should be placed before the forward pass. It can be one device
for the whole module, or a dictionary mapping module name to device.`,name:"execution_device"},{anchor:"accelerate.hooks.attach_align_device_hook_on_blocks.offload",description:`<strong>offload</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the weights should be offloaded after the forward pass. It can be one boolean for the whole
module, or a dictionary mapping module name to boolean.`,name:"offload"},{anchor:"accelerate.hooks.attach_align_device_hook_on_blocks.weights_map",description:`<strong>weights_map</strong> (<code>Mapping[str, torch.Tensor]</code>, <em>optional</em>) &#x2014;
When the model weights are offloaded, a (potentially lazy) map from param names to the tensor values.`,name:"weights_map"},{anchor:"accelerate.hooks.attach_align_device_hook_on_blocks.offload_buffers",description:`<strong>offload_buffers</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to include the associated module&#x2019;s buffers when offloading.`,name:"offload_buffers"},{anchor:"accelerate.hooks.attach_align_device_hook_on_blocks.module_name",description:`<strong>module_name</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
The name of the module.`,name:"module_name"},{anchor:"accelerate.hooks.attach_align_device_hook_on_blocks.preload_module_classes",description:`<strong>preload_module_classes</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
A list of classes whose instances should load all their weights (even in the submodules) at the beginning
of the forward. This should only be used for classes that have submodules which are registered but not
called directly during the forward, for instance if a <code>dense</code> linear layer is registered, but at forward,
<code>dense.weight</code> and <code>dense.bias</code> are used in some operations instead of calling <code>dense</code> directly.`,name:"preload_module_classes"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L417"}}),qe=new Ge({}),Oe=new T({props:{name:"accelerate.hooks.remove_hook_from_module",anchor:"accelerate.hooks.remove_hook_from_module",parameters:[{name:"module",val:": Module"},{name:"recurse",val:" = False"}],parametersDescription:[{anchor:"accelerate.hooks.remove_hook_from_module.module",description:"<strong>module</strong> (<code>torch.nn.Module</code>) &#x2014; The module to attach a hook to.",name:"module"},{anchor:"accelerate.hooks.remove_hook_from_module.recurse",description:"<strong>recurse</strong> (<code>bool</code>, <strong>optional</strong>) &#x2014; Whether to remove the hooks recursively",name:"recurse"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L172",returnDescription:`
<p>The same module, with the hook detached (the module is modified in place, so the result can
be discarded).</p>
`,returnType:`
<p><code>torch.nn.Module</code></p>
`}}),Se=new T({props:{name:"accelerate.hooks.remove_hook_from_submodules",anchor:"accelerate.hooks.remove_hook_from_submodules",parameters:[{name:"module",val:": Module"}],parametersDescription:[{anchor:"accelerate.hooks.remove_hook_from_submodules.module",description:"<strong>module</strong> (<code>torch.nn.Module</code>) &#x2014; The module on which to remove all hooks.",name:"module"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/hooks.py#L405"}}),{c(){p=a("meta"),D=d(),g=a("h1"),u=a("a"),x=a("span"),_(i.$$.fragment),$=d(),N=a("span"),P=r("Working with large models"),E=d(),L=a("h2"),H=a("a"),Be=a("span"),_(ue.$$.fragment),$t=d(),Je=a("span"),xt=r("Dispatching and Offloading Models"),No=d(),C=a("div"),_(ge.$$.fragment),Et=d(),Ke=a("p"),At=r(`A context manager under which models are initialized with all parameters on the meta device, therefore creating an
empty model. Useful when just initializing the model would blow the available RAM.`),Dt=d(),_(oe.$$.fragment),Tt=d(),_(te.$$.fragment),Co=d(),W=a("div"),_(_e.$$.fragment),Mt=d(),Qe=a("p"),Pt=r(`Activates full CPU offload for a model. As a result, all parameters of the model will be offloaded and only one
copy of the state dict of the model will be kept. During the forward pass, parameters will be extracted from that
state dict and put on the execution device passed as they are needed, then offloaded again.`),Uo=d(),S=a("div"),_(ve.$$.fragment),Lt=d(),Xe=a("p"),Ht=r(`Activates full disk offload for a model. As a result, all parameters of the model will be offloaded as
memory-mapped array in a given folder. During the forward pass, parameters will be accessed from that folder and
put on the execution device passed as they are needed, then offloaded again.`),Fo=d(),R=a("div"),_(be.$$.fragment),jt=d(),Ye=a("p"),Nt=r(`Dispatches a model according to a given device map. Layers of the model might be spread across GPUs, offloaded on
the CPU or even the disk.`),Io=d(),U=a("div"),_(ke.$$.fragment),Ct=d(),Ze=a("p"),Ut=r(`Loads a (potentially sharded) checkpoint inside a model, potentially sending weights to a given device as they are
loaded and adds the various hooks that will make this model run properly (even if split across devices).`),Ft=d(),_(ae.$$.fragment),qo=d(),V=a("h2"),ne=a("a"),eo=a("span"),_(we.$$.fragment),It=d(),oo=a("span"),qt=r("Model Hooks"),Oo=d(),z=a("h3"),se=a("a"),to=a("span"),_(ye.$$.fragment),Ot=d(),ao=a("span"),Wt=r("Hook Classes"),Wo=d(),A=a("div"),_($e.$$.fragment),St=d(),no=a("p"),Rt=r(`A hook that contains callbacks to be executed just before and after the forward method of a model. The difference
with PyTorch existing hooks is that they get passed along the kwargs.`),Vt=d(),so=a("p"),zt=r("Class attribute:"),Gt=d(),ro=a("ul"),j=a("li"),lo=a("strong"),Bt=r("no_grad"),Jt=r(" ("),co=a("code"),Kt=r("bool"),Qt=r(", "),io=a("em"),Xt=r("optional"),Yt=r(", defaults to "),ho=a("code"),Zt=r("False"),ea=r(`) \u2014 Whether or not to execute the actual forward pass under
the `),mo=a("code"),oa=r("torch.no_grad()"),ta=r(" context manager."),aa=d(),re=a("div"),_(xe.$$.fragment),na=d(),po=a("p"),sa=r("To be executed when the hook is detached from a module."),ra=d(),le=a("div"),_(Ee.$$.fragment),la=d(),fo=a("p"),da=r("To be executed when the hook is attached to the module."),ca=d(),de=a("div"),_(Ae.$$.fragment),ia=d(),uo=a("p"),ha=r("To be executed just after the forward method of the model."),ma=d(),ce=a("div"),_(De.$$.fragment),pa=d(),go=a("p"),fa=r("To be executed just before the forward method of the model."),So=d(),G=a("div"),_(Te.$$.fragment),ua=d(),Me=a("p"),ga=r("A generic "),_o=a("code"),_a=r("ModelHook"),va=r(` that ensures inputs and model weights are on the same device for the forward pass of the
associated module, potentially offloading the weights after the forward pass.`),Ro=d(),B=a("div"),_(Pe.$$.fragment),ba=d(),vo=a("p"),ka=r("A hook that can contain several hooks and iterates through them at each event."),Vo=d(),J=a("h3"),ie=a("a"),bo=a("span"),_(Le.$$.fragment),wa=d(),ko=a("span"),ya=r("Adding Hooks"),zo=d(),F=a("div"),_(He.$$.fragment),$a=d(),I=a("p"),xa=r("Adds a hook to a given module. This will rewrite the "),wo=a("code"),Ea=r("forward"),Aa=r(` method of the module to include the hook, to remove
this behavior and restore the original `),yo=a("code"),Da=r("forward"),Ta=r(" method, use "),$o=a("code"),Ma=r("remove_hook_from_module"),Pa=r("."),La=d(),_(he.$$.fragment),Go=d(),K=a("div"),_(je.$$.fragment),Ha=d(),Ne=a("p"),ja=r("Recursively attaches "),xo=a("code"),Na=r("AlignDevicesHook"),Ca=r(` to all submodules of a given model to make sure they have the right
execution device`),Bo=d(),Q=a("div"),_(Ce.$$.fragment),Ua=d(),Ue=a("p"),Fa=r("Recursively attaches "),Eo=a("code"),Ia=r("AlignDevicesHook"),qa=r(` to all submodules of a given model that have direct parameters and/or
buffers.`),Jo=d(),X=a("div"),_(Fe.$$.fragment),Oa=d(),Ie=a("p"),Wa=r("Attaches "),Ao=a("code"),Sa=r("AlignDevicesHook"),Ra=r(" to all blocks of a given model as needed."),Ko=d(),Y=a("h3"),me=a("a"),Do=a("span"),_(qe.$$.fragment),Va=d(),To=a("span"),za=r("Removing Hooks"),Qo=d(),Z=a("div"),_(Oe.$$.fragment),Ga=d(),We=a("p"),Ba=r("Removes any hook attached to a module via "),Mo=a("code"),Ja=r("add_hook_to_module"),Ka=r("."),Xo=d(),ee=a("div"),_(Se.$$.fragment),Qa=d(),Po=a("p"),Xa=r("Recursively removes all hooks attached on the submodules of a given model."),this.h()},l(e){const h=Jn('[data-svelte="svelte-1phssyn"]',document.head);p=n(h,"META",{name:!0,content:!0}),h.forEach(t),D=c(e),g=n(e,"H1",{class:!0});var Re=s(g);u=n(Re,"A",{id:!0,class:!0,href:!0});var Lo=s(u);x=n(Lo,"SPAN",{});var Ho=s(x);v(i.$$.fragment,Ho),Ho.forEach(t),Lo.forEach(t),$=c(Re),N=n(Re,"SPAN",{});var jo=s(N);P=l(jo,"Working with large models"),jo.forEach(t),Re.forEach(t),E=c(e),L=n(e,"H2",{class:!0});var Zo=s(L);H=n(Zo,"A",{id:!0,class:!0,href:!0});var Ya=s(H);Be=n(Ya,"SPAN",{});var Za=s(Be);v(ue.$$.fragment,Za),Za.forEach(t),Ya.forEach(t),$t=c(Zo),Je=n(Zo,"SPAN",{});var en=s(Je);xt=l(en,"Dispatching and Offloading Models"),en.forEach(t),Zo.forEach(t),No=c(e),C=n(e,"DIV",{class:!0});var pe=s(C);v(ge.$$.fragment,pe),Et=c(pe),Ke=n(pe,"P",{});var on=s(Ke);At=l(on,`A context manager under which models are initialized with all parameters on the meta device, therefore creating an
empty model. Useful when just initializing the model would blow the available RAM.`),on.forEach(t),Dt=c(pe),v(oe.$$.fragment,pe),Tt=c(pe),v(te.$$.fragment,pe),pe.forEach(t),Co=c(e),W=n(e,"DIV",{class:!0});var et=s(W);v(_e.$$.fragment,et),Mt=c(et),Qe=n(et,"P",{});var tn=s(Qe);Pt=l(tn,`Activates full CPU offload for a model. As a result, all parameters of the model will be offloaded and only one
copy of the state dict of the model will be kept. During the forward pass, parameters will be extracted from that
state dict and put on the execution device passed as they are needed, then offloaded again.`),tn.forEach(t),et.forEach(t),Uo=c(e),S=n(e,"DIV",{class:!0});var ot=s(S);v(ve.$$.fragment,ot),Lt=c(ot),Xe=n(ot,"P",{});var an=s(Xe);Ht=l(an,`Activates full disk offload for a model. As a result, all parameters of the model will be offloaded as
memory-mapped array in a given folder. During the forward pass, parameters will be accessed from that folder and
put on the execution device passed as they are needed, then offloaded again.`),an.forEach(t),ot.forEach(t),Fo=c(e),R=n(e,"DIV",{class:!0});var tt=s(R);v(be.$$.fragment,tt),jt=c(tt),Ye=n(tt,"P",{});var nn=s(Ye);Nt=l(nn,`Dispatches a model according to a given device map. Layers of the model might be spread across GPUs, offloaded on
the CPU or even the disk.`),nn.forEach(t),tt.forEach(t),Io=c(e),U=n(e,"DIV",{class:!0});var Ve=s(U);v(ke.$$.fragment,Ve),Ct=c(Ve),Ze=n(Ve,"P",{});var sn=s(Ze);Ut=l(sn,`Loads a (potentially sharded) checkpoint inside a model, potentially sending weights to a given device as they are
loaded and adds the various hooks that will make this model run properly (even if split across devices).`),sn.forEach(t),Ft=c(Ve),v(ae.$$.fragment,Ve),Ve.forEach(t),qo=c(e),V=n(e,"H2",{class:!0});var at=s(V);ne=n(at,"A",{id:!0,class:!0,href:!0});var rn=s(ne);eo=n(rn,"SPAN",{});var ln=s(eo);v(we.$$.fragment,ln),ln.forEach(t),rn.forEach(t),It=c(at),oo=n(at,"SPAN",{});var dn=s(oo);qt=l(dn,"Model Hooks"),dn.forEach(t),at.forEach(t),Oo=c(e),z=n(e,"H3",{class:!0});var nt=s(z);se=n(nt,"A",{id:!0,class:!0,href:!0});var cn=s(se);to=n(cn,"SPAN",{});var hn=s(to);v(ye.$$.fragment,hn),hn.forEach(t),cn.forEach(t),Ot=c(nt),ao=n(nt,"SPAN",{});var mn=s(ao);Wt=l(mn,"Hook Classes"),mn.forEach(t),nt.forEach(t),Wo=c(e),A=n(e,"DIV",{class:!0});var M=s(A);v($e.$$.fragment,M),St=c(M),no=n(M,"P",{});var pn=s(no);Rt=l(pn,`A hook that contains callbacks to be executed just before and after the forward method of a model. The difference
with PyTorch existing hooks is that they get passed along the kwargs.`),pn.forEach(t),Vt=c(M),so=n(M,"P",{});var fn=s(so);zt=l(fn,"Class attribute:"),fn.forEach(t),Gt=c(M),ro=n(M,"UL",{});var un=s(ro);j=n(un,"LI",{});var q=s(j);lo=n(q,"STRONG",{});var gn=s(lo);Bt=l(gn,"no_grad"),gn.forEach(t),Jt=l(q," ("),co=n(q,"CODE",{});var _n=s(co);Kt=l(_n,"bool"),_n.forEach(t),Qt=l(q,", "),io=n(q,"EM",{});var vn=s(io);Xt=l(vn,"optional"),vn.forEach(t),Yt=l(q,", defaults to "),ho=n(q,"CODE",{});var bn=s(ho);Zt=l(bn,"False"),bn.forEach(t),ea=l(q,`) \u2014 Whether or not to execute the actual forward pass under
the `),mo=n(q,"CODE",{});var kn=s(mo);oa=l(kn,"torch.no_grad()"),kn.forEach(t),ta=l(q," context manager."),q.forEach(t),un.forEach(t),aa=c(M),re=n(M,"DIV",{class:!0});var st=s(re);v(xe.$$.fragment,st),na=c(st),po=n(st,"P",{});var wn=s(po);sa=l(wn,"To be executed when the hook is detached from a module."),wn.forEach(t),st.forEach(t),ra=c(M),le=n(M,"DIV",{class:!0});var rt=s(le);v(Ee.$$.fragment,rt),la=c(rt),fo=n(rt,"P",{});var yn=s(fo);da=l(yn,"To be executed when the hook is attached to the module."),yn.forEach(t),rt.forEach(t),ca=c(M),de=n(M,"DIV",{class:!0});var lt=s(de);v(Ae.$$.fragment,lt),ia=c(lt),uo=n(lt,"P",{});var $n=s(uo);ha=l($n,"To be executed just after the forward method of the model."),$n.forEach(t),lt.forEach(t),ma=c(M),ce=n(M,"DIV",{class:!0});var dt=s(ce);v(De.$$.fragment,dt),pa=c(dt),go=n(dt,"P",{});var xn=s(go);fa=l(xn,"To be executed just before the forward method of the model."),xn.forEach(t),dt.forEach(t),M.forEach(t),So=c(e),G=n(e,"DIV",{class:!0});var ct=s(G);v(Te.$$.fragment,ct),ua=c(ct),Me=n(ct,"P",{});var it=s(Me);ga=l(it,"A generic "),_o=n(it,"CODE",{});var En=s(_o);_a=l(En,"ModelHook"),En.forEach(t),va=l(it,` that ensures inputs and model weights are on the same device for the forward pass of the
associated module, potentially offloading the weights after the forward pass.`),it.forEach(t),ct.forEach(t),Ro=c(e),B=n(e,"DIV",{class:!0});var ht=s(B);v(Pe.$$.fragment,ht),ba=c(ht),vo=n(ht,"P",{});var An=s(vo);ka=l(An,"A hook that can contain several hooks and iterates through them at each event."),An.forEach(t),ht.forEach(t),Vo=c(e),J=n(e,"H3",{class:!0});var mt=s(J);ie=n(mt,"A",{id:!0,class:!0,href:!0});var Dn=s(ie);bo=n(Dn,"SPAN",{});var Tn=s(bo);v(Le.$$.fragment,Tn),Tn.forEach(t),Dn.forEach(t),wa=c(mt),ko=n(mt,"SPAN",{});var Mn=s(ko);ya=l(Mn,"Adding Hooks"),Mn.forEach(t),mt.forEach(t),zo=c(e),F=n(e,"DIV",{class:!0});var ze=s(F);v(He.$$.fragment,ze),$a=c(ze),I=n(ze,"P",{});var fe=s(I);xa=l(fe,"Adds a hook to a given module. This will rewrite the "),wo=n(fe,"CODE",{});var Pn=s(wo);Ea=l(Pn,"forward"),Pn.forEach(t),Aa=l(fe,` method of the module to include the hook, to remove
this behavior and restore the original `),yo=n(fe,"CODE",{});var Ln=s(yo);Da=l(Ln,"forward"),Ln.forEach(t),Ta=l(fe," method, use "),$o=n(fe,"CODE",{});var Hn=s($o);Ma=l(Hn,"remove_hook_from_module"),Hn.forEach(t),Pa=l(fe,"."),fe.forEach(t),La=c(ze),v(he.$$.fragment,ze),ze.forEach(t),Go=c(e),K=n(e,"DIV",{class:!0});var pt=s(K);v(je.$$.fragment,pt),Ha=c(pt),Ne=n(pt,"P",{});var ft=s(Ne);ja=l(ft,"Recursively attaches "),xo=n(ft,"CODE",{});var jn=s(xo);Na=l(jn,"AlignDevicesHook"),jn.forEach(t),Ca=l(ft,` to all submodules of a given model to make sure they have the right
execution device`),ft.forEach(t),pt.forEach(t),Bo=c(e),Q=n(e,"DIV",{class:!0});var ut=s(Q);v(Ce.$$.fragment,ut),Ua=c(ut),Ue=n(ut,"P",{});var gt=s(Ue);Fa=l(gt,"Recursively attaches "),Eo=n(gt,"CODE",{});var Nn=s(Eo);Ia=l(Nn,"AlignDevicesHook"),Nn.forEach(t),qa=l(gt,` to all submodules of a given model that have direct parameters and/or
buffers.`),gt.forEach(t),ut.forEach(t),Jo=c(e),X=n(e,"DIV",{class:!0});var _t=s(X);v(Fe.$$.fragment,_t),Oa=c(_t),Ie=n(_t,"P",{});var vt=s(Ie);Wa=l(vt,"Attaches "),Ao=n(vt,"CODE",{});var Cn=s(Ao);Sa=l(Cn,"AlignDevicesHook"),Cn.forEach(t),Ra=l(vt," to all blocks of a given model as needed."),vt.forEach(t),_t.forEach(t),Ko=c(e),Y=n(e,"H3",{class:!0});var bt=s(Y);me=n(bt,"A",{id:!0,class:!0,href:!0});var Un=s(me);Do=n(Un,"SPAN",{});var Fn=s(Do);v(qe.$$.fragment,Fn),Fn.forEach(t),Un.forEach(t),Va=c(bt),To=n(bt,"SPAN",{});var In=s(To);za=l(In,"Removing Hooks"),In.forEach(t),bt.forEach(t),Qo=c(e),Z=n(e,"DIV",{class:!0});var kt=s(Z);v(Oe.$$.fragment,kt),Ga=c(kt),We=n(kt,"P",{});var wt=s(We);Ba=l(wt,"Removes any hook attached to a module via "),Mo=n(wt,"CODE",{});var qn=s(Mo);Ja=l(qn,"add_hook_to_module"),qn.forEach(t),Ka=l(wt,"."),wt.forEach(t),kt.forEach(t),Xo=c(e),ee=n(e,"DIV",{class:!0});var yt=s(ee);v(Se.$$.fragment,yt),Qa=c(yt),Po=n(yt,"P",{});var On=s(Po);Xa=l(On,"Recursively removes all hooks attached on the submodules of a given model."),On.forEach(t),yt.forEach(t),this.h()},h(){f(p,"name","hf:doc:metadata"),f(p,"content",JSON.stringify(os)),f(u,"id","working-with-large-models"),f(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(u,"href","#working-with-large-models"),f(g,"class","relative group"),f(H,"id","accelerate.init_empty_weights"),f(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(H,"href","#accelerate.init_empty_weights"),f(L,"class","relative group"),f(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(ne,"id","model-hooks"),f(ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(ne,"href","#model-hooks"),f(V,"class","relative group"),f(se,"id","accelerate.hooks.ModelHook"),f(se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(se,"href","#accelerate.hooks.ModelHook"),f(z,"class","relative group"),f(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(de,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(ie,"id","accelerate.hooks.add_hook_to_module"),f(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(ie,"href","#accelerate.hooks.add_hook_to_module"),f(J,"class","relative group"),f(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(me,"id","accelerate.hooks.remove_hook_from_module"),f(me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(me,"href","#accelerate.hooks.remove_hook_from_module"),f(Y,"class","relative group"),f(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,h){o(document.head,p),m(e,D,h),m(e,g,h),o(g,u),o(u,x),b(i,x,null),o(g,$),o(g,N),o(N,P),m(e,E,h),m(e,L,h),o(L,H),o(H,Be),b(ue,Be,null),o(L,$t),o(L,Je),o(Je,xt),m(e,No,h),m(e,C,h),b(ge,C,null),o(C,Et),o(C,Ke),o(Ke,At),o(C,Dt),b(oe,C,null),o(C,Tt),b(te,C,null),m(e,Co,h),m(e,W,h),b(_e,W,null),o(W,Mt),o(W,Qe),o(Qe,Pt),m(e,Uo,h),m(e,S,h),b(ve,S,null),o(S,Lt),o(S,Xe),o(Xe,Ht),m(e,Fo,h),m(e,R,h),b(be,R,null),o(R,jt),o(R,Ye),o(Ye,Nt),m(e,Io,h),m(e,U,h),b(ke,U,null),o(U,Ct),o(U,Ze),o(Ze,Ut),o(U,Ft),b(ae,U,null),m(e,qo,h),m(e,V,h),o(V,ne),o(ne,eo),b(we,eo,null),o(V,It),o(V,oo),o(oo,qt),m(e,Oo,h),m(e,z,h),o(z,se),o(se,to),b(ye,to,null),o(z,Ot),o(z,ao),o(ao,Wt),m(e,Wo,h),m(e,A,h),b($e,A,null),o(A,St),o(A,no),o(no,Rt),o(A,Vt),o(A,so),o(so,zt),o(A,Gt),o(A,ro),o(ro,j),o(j,lo),o(lo,Bt),o(j,Jt),o(j,co),o(co,Kt),o(j,Qt),o(j,io),o(io,Xt),o(j,Yt),o(j,ho),o(ho,Zt),o(j,ea),o(j,mo),o(mo,oa),o(j,ta),o(A,aa),o(A,re),b(xe,re,null),o(re,na),o(re,po),o(po,sa),o(A,ra),o(A,le),b(Ee,le,null),o(le,la),o(le,fo),o(fo,da),o(A,ca),o(A,de),b(Ae,de,null),o(de,ia),o(de,uo),o(uo,ha),o(A,ma),o(A,ce),b(De,ce,null),o(ce,pa),o(ce,go),o(go,fa),m(e,So,h),m(e,G,h),b(Te,G,null),o(G,ua),o(G,Me),o(Me,ga),o(Me,_o),o(_o,_a),o(Me,va),m(e,Ro,h),m(e,B,h),b(Pe,B,null),o(B,ba),o(B,vo),o(vo,ka),m(e,Vo,h),m(e,J,h),o(J,ie),o(ie,bo),b(Le,bo,null),o(J,wa),o(J,ko),o(ko,ya),m(e,zo,h),m(e,F,h),b(He,F,null),o(F,$a),o(F,I),o(I,xa),o(I,wo),o(wo,Ea),o(I,Aa),o(I,yo),o(yo,Da),o(I,Ta),o(I,$o),o($o,Ma),o(I,Pa),o(F,La),b(he,F,null),m(e,Go,h),m(e,K,h),b(je,K,null),o(K,Ha),o(K,Ne),o(Ne,ja),o(Ne,xo),o(xo,Na),o(Ne,Ca),m(e,Bo,h),m(e,Q,h),b(Ce,Q,null),o(Q,Ua),o(Q,Ue),o(Ue,Fa),o(Ue,Eo),o(Eo,Ia),o(Ue,qa),m(e,Jo,h),m(e,X,h),b(Fe,X,null),o(X,Oa),o(X,Ie),o(Ie,Wa),o(Ie,Ao),o(Ao,Sa),o(Ie,Ra),m(e,Ko,h),m(e,Y,h),o(Y,me),o(me,Do),b(qe,Do,null),o(Y,Va),o(Y,To),o(To,za),m(e,Qo,h),m(e,Z,h),b(Oe,Z,null),o(Z,Ga),o(Z,We),o(We,Ba),o(We,Mo),o(Mo,Ja),o(We,Ka),m(e,Xo,h),m(e,ee,h),b(Se,ee,null),o(ee,Qa),o(ee,Po),o(Po,Xa),Yo=!0},p(e,[h]){const Re={};h&2&&(Re.$$scope={dirty:h,ctx:e}),oe.$set(Re);const Lo={};h&2&&(Lo.$$scope={dirty:h,ctx:e}),te.$set(Lo);const Ho={};h&2&&(Ho.$$scope={dirty:h,ctx:e}),ae.$set(Ho);const jo={};h&2&&(jo.$$scope={dirty:h,ctx:e}),he.$set(jo)},i(e){Yo||(k(i.$$.fragment,e),k(ue.$$.fragment,e),k(ge.$$.fragment,e),k(oe.$$.fragment,e),k(te.$$.fragment,e),k(_e.$$.fragment,e),k(ve.$$.fragment,e),k(be.$$.fragment,e),k(ke.$$.fragment,e),k(ae.$$.fragment,e),k(we.$$.fragment,e),k(ye.$$.fragment,e),k($e.$$.fragment,e),k(xe.$$.fragment,e),k(Ee.$$.fragment,e),k(Ae.$$.fragment,e),k(De.$$.fragment,e),k(Te.$$.fragment,e),k(Pe.$$.fragment,e),k(Le.$$.fragment,e),k(He.$$.fragment,e),k(he.$$.fragment,e),k(je.$$.fragment,e),k(Ce.$$.fragment,e),k(Fe.$$.fragment,e),k(qe.$$.fragment,e),k(Oe.$$.fragment,e),k(Se.$$.fragment,e),Yo=!0)},o(e){w(i.$$.fragment,e),w(ue.$$.fragment,e),w(ge.$$.fragment,e),w(oe.$$.fragment,e),w(te.$$.fragment,e),w(_e.$$.fragment,e),w(ve.$$.fragment,e),w(be.$$.fragment,e),w(ke.$$.fragment,e),w(ae.$$.fragment,e),w(we.$$.fragment,e),w(ye.$$.fragment,e),w($e.$$.fragment,e),w(xe.$$.fragment,e),w(Ee.$$.fragment,e),w(Ae.$$.fragment,e),w(De.$$.fragment,e),w(Te.$$.fragment,e),w(Pe.$$.fragment,e),w(Le.$$.fragment,e),w(He.$$.fragment,e),w(he.$$.fragment,e),w(je.$$.fragment,e),w(Ce.$$.fragment,e),w(Fe.$$.fragment,e),w(qe.$$.fragment,e),w(Oe.$$.fragment,e),w(Se.$$.fragment,e),Yo=!1},d(e){t(p),e&&t(D),e&&t(g),y(i),e&&t(E),e&&t(L),y(ue),e&&t(No),e&&t(C),y(ge),y(oe),y(te),e&&t(Co),e&&t(W),y(_e),e&&t(Uo),e&&t(S),y(ve),e&&t(Fo),e&&t(R),y(be),e&&t(Io),e&&t(U),y(ke),y(ae),e&&t(qo),e&&t(V),y(we),e&&t(Oo),e&&t(z),y(ye),e&&t(Wo),e&&t(A),y($e),y(xe),y(Ee),y(Ae),y(De),e&&t(So),e&&t(G),y(Te),e&&t(Ro),e&&t(B),y(Pe),e&&t(Vo),e&&t(J),y(Le),e&&t(zo),e&&t(F),y(He),y(he),e&&t(Go),e&&t(K),y(je),e&&t(Bo),e&&t(Q),y(Ce),e&&t(Jo),e&&t(X),y(Fe),e&&t(Ko),e&&t(Y),y(qe),e&&t(Qo),e&&t(Z),y(Oe),e&&t(Xo),e&&t(ee),y(Se)}}}const os={local:"working-with-large-models",sections:[{local:"accelerate.init_empty_weights",title:"Dispatching and Offloading Models"},{local:"model-hooks",sections:[{local:"accelerate.hooks.ModelHook",title:"Hook Classes"},{local:"accelerate.hooks.add_hook_to_module",title:"Adding Hooks"},{local:"accelerate.hooks.remove_hook_from_module",title:"Removing Hooks"}],title:"Model Hooks"}],title:"Working with large models"};function ts(O){return Kn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class cs extends zn{constructor(p){super();Gn(this,p,ts,es,Bn,{})}}export{cs as default,os as metadata};
